package server

import (
	"flag"
	"fmt"
	"git.smsvc.net/pomodoro/GoTomato/internal/websocket"
	"git.smsvc.net/pomodoro/GoTomato/pkg/models"
	"log"
	"net/http"
)

func Start() {
	// Define CLI flags for ListenAddress and ListenPort
	listenAddress := flag.String("listenAddress", "0.0.0.0", "IP address to listen on")
	listenPort := flag.Int("listenPort", 8080, "Port to listen on")
	flag.Parse()

	serverConfig := models.GoTomatoServerConfig{
		ListenAddress: *listenAddress,
		ListenPort:    *listenPort,
	}

	listen := fmt.Sprintf("%s:%d", serverConfig.ListenAddress, serverConfig.ListenPort)

	http.HandleFunc("/ws", websocket.HandleConnections)
	go websocket.SendPermanentBroadCastMessage()

	log.Printf("Pomodoro WebSocket server started on %s\n", listen)
	err := http.ListenAndServe(listen, nil)
	if err != nil {
		log.Fatalf("Error starting server: %v", err)
	}
}
